C This code has been developed under THALIS: MATENVMED project for Action 2.1 and co-financed by Greece and EU - NSRF 2007-2013.
C This Cuda Foertan GPU version of BiCGSTAB is used for solving the brain problem
C
        module bicgstabGPU
        contains
         subroutine bicgstabGPU(n,x,b,A,iA,jA,FA,iFA,jFA,
     +                       nzA,descrA,handle,error,r,rh,pi,ph,
     +                       t,s,sh,ui,istep,temp,ttt)
      implicit real*8 (a-h,o-z)
      real*8 FA(*),temp(n),ttt(*)
      integer*8 handle,descrA,iA,jA,A,
     +           x,b,r,rh,pi,ph,s,sh,ui,t
      integer   cusparse_dcsrmv,iFA(*),jFA(*),
     +   cuda_memcpy_c2fort_real,cuda_memcpy_fort2c_real


      imaxstep=istep
      tol=error
      istep=0
      dnrmb=cublas_dnrm2(n,b,1) 
      call cublas_dcopy(n,b,1,x,1)
      istatus=cusparse_dcsrmv(handle,0,n,n,nzA,1.0d0,descrA,A,iA,jA,
     +         x,0.0d0,r)
      call cublas_dscal(n,-1.0d0,r,1)
      call cublas_daxpy(n,1.0d0,b,1,r,1)
      call cublas_dcopy(n,r,1,rh,1)
999   continue
      istep=istep+1
      if (istep.gt.1) roip2=roip1
       roip1=cublas_ddot(n,rh,1,r,1)
      if (istep.eq.1) then
       call cublas_dcopy(n,r,1,pi,1)
      else
       bi=(roip1/roip2)*(ai/wi)
       call cublas_daxpy(n,-wi,ui,1,pi,1)
       call cublas_dcopy(n,r,1,t,1)
       call cublas_daxpy(n,bi,pi,1,t,1)
       call cublas_dcopy(n,t,1,pi,1)
      endif
       icudaStat = cuda_memcpy_c2fort_real(temp,pi,n*8,2)
       call lusol(n,temp,ttt,fA,jfA,iFA)
      icudaStat3 = cuda_memcpy_fort2c_real(ph,ttt,n*8,1)
      istatus=cusparse_dcsrmv(handle,0,n,n,nzA,1.0d0,descrA,A,iA,jA,
     +         ph,0.0d0,ui)
      ai=roip1/cublas_ddot(n,rh,1,ui,1)
      call cublas_dcopy(n,r,1,s,1)
      call cublas_daxpy(n,-ai,ui,1,s,1)
      if (cublas_dnrm2(n,s,1).lt.1.0d-45) then
      call cublas_daxpy(n,ai,ph,1,x,1)
       print*,'BiCGSTAB incomplete'
      else
       icudaStat = cuda_memcpy_c2fort_real(temp,s,n*8,2)
       call lusol(n,temp,ttt,FA,jFA,iFA)
      icudaStat3 = cuda_memcpy_fort2c_real(sh,ttt,n*8,1)
      istatus=cusparse_dcsrmv(handle,0,n,n,nzA,1.0d0,descrA,A,iA,jA,
     +         sh,0.0d0,t)
      wi=cublas_ddot(n,t,1,s,1)/cublas_ddot(n,t,1,t,1)
      call cublas_daxpy(n,ai,ph,1,x,1)
      call cublas_daxpy(n,wi,sh,1,x,1)
      call cublas_daxpy(n,-wi,t,1,s,1)
      call cublas_dcopy(n,s,1,r,1)
       dnrmr=cublas_dnrm2(n,s,1)
       error=dnrmr/dnrmb
      if (wi.ne.0.0d0.and.error.gt.tol.and.istep.lt.imaxstep)
     + goto 999
      endif
      return
      end
      end  module 
