C ==================================================
C |-------Instructions-----------------------------|
C |                                                |
C | This subroutine performs a kronecker product   |
C | between two sparse matrices of dimension ,     |
C | (nza) and (nzb). The result finally stored     |
C | at matrix c with dimension (nza*nzb).          |
C |                                                |
C | THIS IS THE SPARSE VERSION OF kron.f           |
C | format used :: CSR                             |
C |                                                |
C | INPUT ARGUMENTS:..                             |
C |                                                |
C | ma :: INTEGER arrays of A                      |
C | na :: INTEGER columns of A                     |
C | a  :: REAL*8  sparse matrix A (array)          |
C | ja :: INTEGER array-pointer for collumns of A  |
C | ia :: INTEGER array-pointer for elements that  |
C |change line of matrix A                         |
C | mb :: INTEGER arrays of B                      |
C | nb :: INTEGER columns of B                     |
C | b  :: REAL*8  sparse matrix B (array)          |
C | jb :: INTEGER array-pointer for collumns of B  |
C | ib :: INTEGER array-pointer for elements that  |
C |change line of matrix B                         |
C |                                                |
C | OUTPUT ARGUMENTS:..                            |
C |                                                |
C | c  :: REAL*8  sparse matrix C (array)          |
C | jc :: INTEGER array-pointer for collumns of C  |
C | ic :: INTEGER array-pointer for elements that  |
C |change line of matrix C                         |
C |________________________________________________|
C 
C 
C Date   :: 11/5/2012.

       subroutine krons(ma,na,a,ja,ia,mb,nb,b,jb,ib,c,jc,ic,iac)

       real*8 a(*),b(*),c(*)
       integer ja(*),jb(*),ia(*),ib(*),jc(*),ic(*)
       integer tmpi,w,q,point,iac(*)


       q=0
       do k=1,ma
              do i=1,mb
       do l=ia(k),ia(k+1)-1

              do j=ib(i),ib(i+1)-1
              q=q+1
              c(q)=a(l)*b(j)
              iac(q)=(k-1)*mb+i
              jc(q)=(ja(l)-1)*nb+jb(j)  

              enddo
              enddo
        enddo
        enddo

       ic(1)=iac(1)
       w=1
       do i=1,q-1
       tmpi=iac(i)
       if (tmpi.ne.iac(i+1)) then
       w=w+1
       ic(w)=i+1
	endif
	enddo
	ic(w+1)=ic(1)+q


        return
        end

              
              
              

       
