C This code has been developed under THALIS: MATENVMED project for Action 2.1 and co-financed by Greece and EU - NSRF 2007-2013.
C This Cuda Fortran code is used for solving the brain problem  and is compatible for PGI CDK compiler suite ver. 15.3 +.

        use cublas
        use cudafor
        use openacc
        use omp_lib
        use bicgstabGPU
        implicit real*8 (a-h,o-z)
        parameter (kns=5,ns=20*2**kns,n=4*ns*ns,n1=n+1,nx=16*n,
     +            nz=2*ns*n)
        real*8 h(3),K2(2,4),K0(2,4),K0D(2,4),K2D(2,4),C2X(2*ns,2*ns),
     +        C0X(2*ns,2*ns),C0Y(2*ns,2*ns),C2Y(2*ns,2*ns),rr,kk,
     +       SC2X(nx),SC2Y(nx),SC0X(nx),SC0Y(nx),a1(n),a2(n),
     +       A00(nx),A02(nx),A20(nx),ww(n1),fA00(nz),aold(n),
     +        B(nx),A(nx),fA(nz),anew(n),a0old(n),BR(nx),
     +       r(n),rh(n),pi(n),ph(n),t(n),s(n),sh(n),ui(n),temp(n),
     +     BK(nx),BRK(nx),AR(nx),AK(nx),ARK(nx)
        integer nel(3),isc2x(nx),jsc2x(nx),isc2y(nx),tr(500),iBRK(nx),
     +          jsc2y(nx),isc0x(nx),jsc0x(nx),isc0y(nx),iBR(nx),jBR(nx),
     +          jsc0y(nx),iA00(nx),jA00(nx),ifA(nz),jfA(nz),jBRK(nx),
     +          iA02(nx),jA02(nx),iA20(nx),iw(n*n+1),
     +        jA20(nx),iB(nx),jB(nx),iA(nx),jA(nx),ifA00(nz),jfA00(nz),
     +        iBK(nx),jBK(nx),iAK(nx),jAK(nx),
     +           iAR(nx),jAR(nx),iARK(nx),jARK(nx)
       integer status,cusparse_dcsrmv,cusparse_create,cusparse_destroy,
     $ cusparse_create_mat_descr,cusparse_destroy_mat_descr,
     $  cusparse_set_mat_type,cusparse_set_mat_index_base,fmode,dtype,
     $cusparse_get_mat_type,cusparse_get_mat_fill_mode,
     $  cusparse_get_mat_index_base,cusparse_get_diag_type,
     $ cuda_malloc,cuda_memcpy_c2fort_int,cuda_memcpy_c2fort_real,
     $cuda_memcpy_fort2c_int,cuda_memcpy_fort2c_real,
     $cusparse_create_solve_analysis_info,cusparse_set_mat_diag_type,
     $cusparse_set_mat_fill_mode,cusparse_dcsrsm_analysis,
     $cusparse_dcsrsm_solve
        integer*8 handle,descrA,iAg,jAg,Ag,
     +            descrB,iBg,jBg,Bg,
     +            descrBr,iBrg,jBrg,Brg,
     +            descrBk,iBkg,jBkg,Bkg,
     +            descrBrk,iBrkg,jBrkg,Brkg,
     +            descrAr,iArg,jArg,Arg,
     +            descrAk,iAkg,jAkg,Akg,
     +            descrArk,iArkg,jArkg,Arkg,
     +            descrA00,iA00g,jA00g,A00g,
     +            a1g,a2g,aoldg,anewg,a0oldg,rg,rhg,pig,phg,tg,sg,shg,
     +            uig,tempg
       real cputime1,cputime2


        call OMP_set_num_threads(1)
        print*,'Ns = ',ns,' N =',n,' OMP THREADS= ',OMP_get_max_threads()
        print*,'Ns  = ',ns,'  N =',n
        tmax=6.0d0
        dt=0.012d0
        call acc_init(acc_device_nvidia)

        rr=4.756541098918d0
        kk=1.633333333333d0
        do i=1,500
          tr(i)=0
        enddo
        do i=180,209
          tr(i)=1
        enddo
        do i=210,220
          tr(i)=3
        enddo
        do i=221,240
          tr(i)=2
        enddo
        g=0.5d0
        nel(1)=8*2**kns
        nel(2)=4*2**kns
        nel(3)=8*2**kns

        h(1)=4.0d0/dfloat(nel(1))
        h(2)=2.0d0/dfloat(nel(2))
        h(3)=h(1)
C Create collocation matrices
        call mkd(ns,nel,h,C2X,C0X,K2,K0,K0D,K2D)
        call mkc(ns,0.5d0/2**kns,C2Y,C0Y,K2,K0)

        k=2*(nel(1)+nel(2))
        do i=1,2*nel(1)
          do j=1,2*ns
           C2X(i,j)=C2X(i,j)*g
           C2X(k+i,j)=C2X(k+i,j)*g
         enddo
        enddo
        nzmax=8*ns

        call dns2csr(ns,nzmax,C2X,SC2X,jsc2x,isc2x,info)
        call dns2csr(ns,nzmax,C2Y,SC2Y,jsc2y,isc2y,info)
        call dns2csr(ns,nzmax,C0X,SC0X,jsc0x,isc0x,info)
        call dns2csr(ns,nzmax,C0Y,SC0Y,jsc0y,isc0y,info)
        call krons(2*ns,2*ns,SC0X,jsc0x,isc0x,2*ns,2*ns,SC0Y,jsc0y,
     +             isc0y,A00,jA00,iA00,iw)
        call krons(2*ns,2*ns,SC2X,jsc2x,isc2x,2*ns,2*ns,SC0Y,jsc0y,
     +             isc0y,A20,jA20,iA20,iw)

        call mkd(ns,nel,h,C2X,C0X,K2,K0,K0D,K2D)
        k=2*(nel(1)+nel(2))
        do i=1,2*nel(1)
          do j=1,2*ns
           C0X(i,j)=C0X(i,j)*g
           C0X(k+i,j)=C0X(k+i,j)*g
         enddo
        enddo
        call dns2csr(ns,nzmax,C0X,SC0X,jsc0x,isc0x,info)

        call krons(2*ns,2*ns,SC0X,jsc0x,isc0x,2*ns,2*ns,SC2Y,jsc2y,
     +             isc2y,A02,jA02,iA02,iw)

        call aplsb(n,n,A20,jA20,iA20,1.0d0,A02,jA02,iA02,
     +             B,jB,iB,nx,iw,ierr)

        ddt=-dt*(0.5d0+dsqrt(3.0d0)/6.0d0)
        rrr=1.0d0-rr
        rbb=1.0d0-kk
        rkr=1.0d0-rr-kk
        call aplsb(4*ns*ns,4*ns*ns,A00,jA00,iA00,1.0d0,B,jB,iB,
     +             A,jA,iA,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,B,jB,iB,rrr,A00,jA00,iA00,
     +             BR,jBR,iBR,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,B,jB,iB,rbb,A00,jA00,iA00,
     +             BK,jBK,iBK,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,B,jB,iB,rkr,A00,jA00,iA00,
     +             BRK,jBRK,iBRK,nx,iw,ierr)
        call dcopy(nx,A,1,B,1)
        do i=1,nx
          jB(i)=jA(i)
          iB(i)=iA(i)
        enddo
        call aplsb(4*ns*ns,4*ns*ns,A00,jA00,iA00,ddt,B,jB,iB,
     +             A,jA,iA,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,A00,jA00,iA00,ddt,BK,jBK,iBK,
     +             AK,jAK,iAK,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,A00,jA00,iA00,ddt,BR,jBR,iBR,
     +             AR,jAR,iAR,nx,iw,ierr)
        call aplsb(4*ns*ns,4*ns*ns,A00,jA00,iA00,ddt,BRK,jBRK,iBRK,
     +             ARK,jARK,iARK,nx,iw,ierr)

C Import the initial condition
        open(7,file='aold.txt')
        do i=1,n
         read(7,*) aold(i)
        enddo
       close(7)
        print*,'CSR matrices are OK'
        ns2=int(ns/2)
      tm0=omp_get_wtime()
       call ilut(n,A00,jA00,iA00,ns,1.0d-4,fA00,jFA00,iFA00,
     +           nz,ww,iw,info)
       if (info.ne.0) print*,'Error for A00 iLU =',info
       if (info.ne.0) stop
        print*,'CSR iLU for A00 is  OK'
       call ilut(n,A,jA,iA,ns,1.0d-4,fA,jFA,iFA,nz,ww,iw,info)
       if (info.ne.0) print*,'Error for A iLU =',info
       if (info.ne.0) stop
        print*,'CSR iLU for A is  OK'
       tm=omp_get_wtime()-tm0
       print*,'Time for iLU =',tm,'  seconds'
       print*,'||a init||2=',dnrm2(n,aold,1)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       nzb=iB(n1)-1
       nzbr=iBr(n1)-1
       nzbk=iBk(n1)-1
       nzbrk=iBrk(n1)-1
       nza=iA(n1)-1
       nza00=iA00(n1)-1
       nzar=iAr(n1)-1
       nzak=iAk(n1)-1
       nzark=iArk(n1)-1
C Load matrices on GPU
       istatus = cusparse_create(handle)
       icudaStat1 = cuda_malloc(jAg,nza*4)
       icudaStat2 = cuda_malloc(iAg,n1*4)
       icudaStat3 = cuda_malloc(Ag,nza*8)
       icudaStat1 = cuda_malloc(jArg,nzar*4)
       icudaStat2 = cuda_malloc(iArg,n1*4)
       icudaStat3 = cuda_malloc(Arg,nzar*8)
       icudaStat1 = cuda_malloc(jAkg,nzak*4)
       icudaStat2 = cuda_malloc(iAkg,n1*4)
       icudaStat3 = cuda_malloc(Akg,nzak*8)
       icudaStat1 = cuda_malloc(jArkg,nzark*4)
       icudaStat2 = cuda_malloc(iArkg,n1*4)
       icudaStat3 = cuda_malloc(Arkg,nzark*8)
       icudaStat1 = cuda_malloc(jA00g,nza00*4)
       icudaStat2 = cuda_malloc(iA00g,n1*4)
       icudaStat3 = cuda_malloc(A00g,nza00*8)
       icudaStat1 = cuda_malloc(jBg,nzb*4)
       icudaStat2 = cuda_malloc(iBg,n1*4)
       icudaStat3 = cuda_malloc(Bg,nzb*8)
       icudaStat4 = cuda_malloc(rg,n*8)
       icudaStat5 = cuda_malloc(rhg,n*8)
       icudaStat5 = cuda_malloc(tg,n*8)
       icudaStat5 = cuda_malloc(a1g,n*8)
       icudaStat5 = cuda_malloc(a2g,n*8)
       icudaStat5 = cuda_malloc(a0oldg,n*8)
       icudaStat5 = cuda_malloc(aoldg,n*8)
       icudaStat5 = cuda_malloc(anewg,n*8)
       icudaStat5 = cuda_malloc(pig,n*8)
       icudaStat5 = cuda_malloc(uig,n*8)
       icudaStat5 = cuda_malloc(phg,n*8)
       icudaStat5 = cuda_malloc(shg,n*8)
       icudaStat5 = cuda_malloc(sg,n*8)
       icudaStat5 = cuda_malloc(tempg,n*8)
       icudaStat1 = cuda_malloc(jBrg,nzbr*4)
       icudaStat2 = cuda_malloc(iBrg,n1*4)
       icudaStat3 = cuda_malloc(Brg,nzbr*8)
       icudaStat1 = cuda_malloc(jBrkg,nzbrk*4)
       icudaStat2 = cuda_malloc(iBrkg,n1*4)
       icudaStat3 = cuda_malloc(Brkg,nzbrk*8)
       icudaStat1 = cuda_malloc(jBkg,nzbk*4)
       icudaStat2 = cuda_malloc(iBkg,n1*4)
       icudaStat3 = cuda_malloc(Bkg,nzbk*8)

      tm0=omp_get_wtime()
      icudaStat1 = cuda_memcpy_fort2c_int(jA00g,jA00,nza00*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iA00g,iA00,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(A00g,A00,nza00*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jAg,jA,nza*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iAg,iA,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Ag,A,nza*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jBg,jB,nzb*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iBg,iB,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Bg,B,nzb*8,1)
      icudaStat4 = cuda_memcpy_fort2c_real(aoldg,aold,n*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jArg,jAr,nzar*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iArg,iAr,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Arg,Ar,nzar*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jArkg,jArk,nzark*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iArkg,iArk,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Arkg,Ark,nzark*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jAkg,jAk,nzak*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iAkg,iAk,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Akg,Ak,nzak*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jBrg,jBr,nzbr*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iBrg,iBr,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Brg,Br,nzbr*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jBrkg,jBrk,nzbrk*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iBrkg,iBrk,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Brkg,Brk,nzbrk*8,1)
      icudaStat1 = cuda_memcpy_fort2c_int(jBkg,jBk,nzbk*4,1)
      icudaStat2 = cuda_memcpy_fort2c_int(iBkg,iBk,n1*4,1)
      icudaStat3 = cuda_memcpy_fort2c_real(Bkg,Bk,nzbk*8,1)
      tm=omp_get_wtime()-tm0
        print*,'Memcpy  CPU ---> GPU is OK in ',tm,'  seconds'

       status= cusparse_create_mat_descr(descrA00)
       status = cusparse_set_mat_type(descrA00,0)
       status = cusparse_set_mat_index_base(descrA00,1)
       status= cusparse_create_mat_descr(descrB)
       status = cusparse_set_mat_type(descrB,0)
       status = cusparse_set_mat_index_base(descrB,1)
       status= cusparse_create_mat_descr(descrA)
       status = cusparse_set_mat_type(descrA,0)
       status = cusparse_set_mat_index_base(descrA,1)
       status= cusparse_create_mat_descr(descrAr)
       status = cusparse_set_mat_type(descrAr,0)
       status = cusparse_set_mat_index_base(descrAr,1)
       status= cusparse_create_mat_descr(descrArk)
       status = cusparse_set_mat_type(descrArk,0)
       status = cusparse_set_mat_index_base(descrArk,1)
       status= cusparse_create_mat_descr(descrAk)
       status = cusparse_set_mat_type(descrAk,0)
       status = cusparse_set_mat_index_base(descrAk,1)
       status= cusparse_create_mat_descr(descrBr)
       status = cusparse_set_mat_type(descrBr,0)
       status = cusparse_set_mat_index_base(descrBr,1)
       status= cusparse_create_mat_descr(descrBrk)
       status = cusparse_set_mat_type(descrBrk,0)
       status = cusparse_set_mat_index_base(descrBrk,1)
       status= cusparse_create_mat_descr(descrBk)
       status = cusparse_set_mat_type(descrBk,0)
       status = cusparse_set_mat_index_base(descrBk,1)
       is=cublasinit()
       if (is.ne.0) print*,'CUBLAS ERROR =',is
      dl=-dsqrt(3.0d0)/3.0d0 
      call cpu_time(cputime1)
      tm0=omp_get_wtime()
      k=0
C Time iterations
      do tx=dt,tmax,dt
         istatus=cusparse_dcsrmv(handle,0,n,n,nza00,1.0d0,descrA00,
     +                         A00g,iA00g,jA00g,aoldg,0.0d0,a0oldg)
          istep=50
          error=1.0d-12
        if (tr(k+1).eq.0) then
          call bicgstabGPU(n,a1g,a0oldg,Ag,iAg,jAg,FA,iFA,jFA,nza,
     +               descrA,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
         call cublas_dcopy(n,a0oldg,1,anewg,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzb,dl*dt,descrB,
     +                         Bg,iBg,jBg,a1g,1.0d0,anewg)
          call bicgstabGPU(n,a2g,anewg,Ag,iAg,jAg,FA,iFA,jFA,nza,
     +               descrA,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
          call cublas_daxpy(n,1.0d0,a1g,1,a2g,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzb,0.5d0*dt,descrB,
     +                         Bg,iBg,jBg,a2g,1.0d0,a0oldg)
          call bicgstabGPU(n,anewg,a0oldg,A00g,iA00g,jA00g,FA00,iFA00,
     +              jFA00,nza,descrA00,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
        elseif (tr(k+1).eq.1) then
         call bicgstabGPU(n,a1g,a0oldg,Arg,iArg,jArg,FA,iFA,jFA,nzar,
     +               descrAr,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
         call cublas_dcopy(n,a0oldg,1,anewg,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbr,dl*dt,descrBr,
     +                         Brg,iBrg,jBrg,a1g,1.0d0,anewg)
          call bicgstabGPU(n,a2g,anewg,Arg,iArg,jArg,FA,iFA,jFA,nzar,
     +               descrAr,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
          call cublas_daxpy(n,1.0d0,a1g,1,a2g,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbr,0.5d0*dt,descrBr,
     +                         Brg,iBrg,jBrg,a2g,1.0d0,a0oldg)
          call bicgstabGPU(n,anewg,a0oldg,A00g,iA00g,jA00g,FA00,iFA00,
     +              jFA00,nza,descrA00,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
        elseif (tr(k+1).eq.2) then
         call bicgstabGPU(n,a1g,a0oldg,Akg,iAkg,jAkg,FA,iFA,jFA,nzak,
     +               descrAk,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
         call cublas_dcopy(n,a0oldg,1,anewg,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbk,dl*dt,descrBk,
     +                         Bkg,iBkg,jBkg,a1g,1.0d0,anewg)
          call bicgstabGPU(n,a2g,anewg,Akg,iAkg,jAkg,FA,iFA,jFA,nzak,
     +               descrAk,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
          call cublas_daxpy(n,1.0d0,a1g,1,a2g,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbk,0.5d0*dt,descrBk,
     +                         Bkg,iBkg,jBkg,a2g,1.0d0,a0oldg)
          call bicgstabGPU(n,anewg,a0oldg,A00g,iA00g,jA00g,FA00,iFA00,
     +              jFA00,nza,descrA00,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
        else
         call bicgstabGPU(n,a1g,a0oldg,Arkg,iArkg,jArkg,FA,iFA,
     +          jFA,nzark,descrArk,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
         call cublas_dcopy(n,a0oldg,1,anewg,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbrk,dl*dt,descrBrk,
     +                         Brkg,iBrkg,jBrkg,a1g,1.0d0,anewg)
        call bicgstabGPU(n,a2g,anewg,Arkg,iArkg,jArkg,FA,iFA,jFA,
     +             nzark,descrArk,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
          istep=50
          error=1.0d-12
          call cublas_daxpy(n,1.0d0,a1g,1,a2g,1)
         istatus=cusparse_dcsrmv(handle,0,n,n,nzbrk,0.5d0*dt,descrBrk,
     +                         Brkg,iBrkg,jBrkg,a2g,1.0d0,a0oldg)
          call bicgstabGPU(n,anewg,a0oldg,A00g,iA00g,jA00g,FA00,iFA00,
     +              jFA00,nza,descrA00,handle,error,rg,rhg,pig,phg,
     +               tg,sg,shg,uig,istep,temp,a1)
         endif
         call cublas_dcopy(n,anewg,1,aoldg,1)
         k=k+1
       enddo
       icudaStat = cuda_memcpy_c2fort_real(aold,aoldg,n*8,2)
       print*,'||a||2=',dnrm2(n,aold,1),' at ',tx-dt,' final time step'

      tm=omp_get_wtime()-tm0
      call cpu_time(cputime2)
      print*,'GPU Computations in ',(cputime2-cputime1)/60.0e0,' mins '
      print*,'GPU Computations in ',tm,' seconds for ',k,' time steps'
      stop
      end      
